// PPgGeneral.cpp : implementation file
//

//#include "stdafx.h"
#include "wintypes.h"
#include "amule.h"
#include "PPgGeneral.h"
#include "muuli_wdr.h"

#include <wx/checkbox.h>
#include <wx/notebook.h>
#include <wx/slider.h>

// CPPgGeneral dialog


//IMPLEMENT_DYNAMIC(CPPgGeneral, CPropertyPage)
IMPLEMENT_DYNAMIC_CLASS(CPPgGeneral,wxPanel)

CPPgGeneral::CPPgGeneral(wxWindow* parent)
:wxPanel(parent,CPPgGeneral::IDD) //: CPropertyPage(CPPgGeneral::IDD)
{
	wxNotebook* book=(wxNotebook*)parent;

	wxSizer* page1=PreferencesGeneralTab(this,TRUE);
	book->AddPage(this,_("General"));
}

CPPgGeneral::~CPPgGeneral()
{
}

BEGIN_EVENT_TABLE(CPPgGeneral,wxPanel)
	EVT_SCROLL(CPPgGeneral::OnHScroll)
	EVT_BUTTON(ID_DESKTOPMODE,CPPgGeneral::OnDesktopmode)
END_EVENT_TABLE()

void CPPgGeneral::OnDesktopmode(wxEvent& evt)
{
	theApp.amuledlg->changeDesktopMode();
}

#include <wx/checkbox.h>

void CPPgGeneral::LoadSettings(void)
{
	// Barry - Controls depth of 3d colour shading
	((wxSlider*)FindWindowById(IDC_3DDEPTH))->SetValue(app_prefs->Get3DDepth());

	((wxSlider*)FindWindowById(IDC_CHECKDAYS))->SetValue(app_prefs->GetUpdateDays());

	((wxTextCtrl*)FindWindowById(IDC_NICK))->SetValue(app_prefs->prefs->nick);

	if(app_prefs->prefs->startMinimized) {
		((wxCheckBox*)FindWindowById(IDC_STARTMIN))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_STARTMIN))->SetValue(FALSE);
	}

	if(app_prefs->prefs->mintotray) {
		((wxCheckBox*)FindWindowById(IDC_MINTRAY))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_MINTRAY))->SetValue(FALSE);
	}
  
	if (app_prefs->prefs->onlineSig) {
		((wxCheckBox*)FindWindowById(IDC_ONLINESIG))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_ONLINESIG))->SetValue(FALSE);
	}
  
	if(app_prefs->prefs->beepOnError) {
		((wxCheckBox*)FindWindowById(IDC_BEEPER))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_BEEPER))->SetValue(FALSE);
	}
  
	if(app_prefs->prefs->confirmExit) {
		((wxCheckBox*)FindWindowById(IDC_EXIT))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_EXIT))->SetValue(FALSE);
	}
  
	if(app_prefs->prefs->splashscreen) {
		((wxCheckBox*)FindWindowById(IDC_SPLASHON))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_SPLASHON))->SetValue(FALSE);
	}
  
	if(app_prefs->prefs->transferDoubleclick) {
		((wxCheckBox*)FindWindowById(IDC_DBLCLICK))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_DBLCLICK))->SetValue(FALSE);
	}
  
	if(app_prefs->prefs->bringtoforeground) {
		((wxCheckBox*)FindWindowById(IDC_BRINGTOFOREGROUND))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_BRINGTOFOREGROUND))->SetValue(FALSE);
	}
  
	if(app_prefs->prefs->updatenotify) {
		((wxCheckBox*)FindWindowById(IDC_CHECK4UPDATE))->SetValue(TRUE);
	} else {
		((wxCheckBox*)FindWindowById(IDC_CHECK4UPDATE))->SetValue(FALSE);
	}
  
	CString strBuffer;
	strBuffer.Format("%d", app_prefs->prefs->m_iToolDelayTime);
	((wxSpinCtrl*)FindWindowById(IDC_TOOLTIPDELAY))->SetValue(strBuffer);

	strBuffer.Format("%i",app_prefs->prefs->versioncheckdays);
	((wxStaticText*)FindWindowById(IDC_DAYS))->SetLabel(strBuffer);
}

void CPPgGeneral::OnApply()
{
	wxString buffer;
	if (((wxTextCtrl*)FindWindowById(IDC_NICK))->GetValue().Length()) {
		buffer=((wxTextCtrl*)FindWindowById(IDC_NICK))->GetValue();
	} else {
		buffer="Someone using aMule (http://amule.sourceforge.net)";
	}
	strcpy(app_prefs->prefs->nick,buffer);
  
	int8 mintotray_old= app_prefs->prefs->mintotray;
	app_prefs->prefs->startMinimized= (int8)(((wxCheckBox*)FindWindowById(IDC_STARTMIN))->GetValue());
	app_prefs->prefs->mintotray = (int8)(((wxCheckBox*)FindWindowById(IDC_MINTRAY))->GetValue());
	app_prefs->prefs->beepOnError= (int8)(((wxCheckBox*)FindWindowById(IDC_BEEPER))->GetValue());
	app_prefs->prefs->confirmExit= (int8)(((wxCheckBox*)FindWindowById(IDC_EXIT))->GetValue());
	app_prefs->prefs->splashscreen = (int8)(((wxCheckBox*)FindWindowById(IDC_SPLASHON))->GetValue());
	app_prefs->prefs->transferDoubleclick= (int8)(((wxCheckBox*)FindWindowById(IDC_DBLCLICK))->GetValue());
	app_prefs->prefs->bringtoforeground = (int8)(((wxCheckBox*)FindWindowById(IDC_BRINGTOFOREGROUND))->GetValue());
	app_prefs->prefs->updatenotify = (int8)(((wxCheckBox*)FindWindowById(IDC_CHECK4UPDATE))->GetValue());
	app_prefs->prefs->onlineSig= (int8)(((wxCheckBox*)FindWindowById(IDC_ONLINESIG))->GetValue());
	app_prefs->prefs->depth3D = ((wxSlider*)FindWindowById(IDC_3DDEPTH))->GetValue();
  	app_prefs->prefs->versioncheckdays = ((wxSlider*)FindWindowById(IDC_CHECKDAYS))->GetValue();
	int bigbobbuffer=(((wxSpinCtrl*)FindWindowById(IDC_TOOLTIPDELAY))->GetValue());
	app_prefs->prefs->m_iToolDelayTime = bigbobbuffer;

	LoadSettings();
}

void CPPgGeneral::Localize(void)
{
}

void CPPgGeneral::OnHScroll(wxScrollEvent& evt)
{
	wxSlider* slider=(wxSlider*)evt.GetEventObject();
	if (slider==((wxSlider*)FindWindowById(IDC_CHECKDAYS))) {
		CString text;
		text.Format("%i",evt.GetPosition());
		((wxStaticText*)FindWindowById(IDC_DAYS))->SetLabel(text);
	}
}
