// PPgStats.cpp : implementation file
//

//#include "stdafx.h"
#include "wintypes.h"
#include "amule.h"
#include "PPgStats.h"
#include "muuli_wdr.h"

#include <wx/checkbox.h>
#include <wx/notebook.h>
#include <wx/slider.h>
#include <wx/colordlg.h>

#define GetRValue(rgb) (((rgb)>>16)&0xff)
#define GetGValue(rgb) (((rgb)>>8)&0xff)
#define GetBValue(rgb) ((rgb)&0xff)

// CPPgStats dialog

IMPLEMENT_DYNAMIC_CLASS(CPPgStats,wxPanel)

CPPgStats::CPPgStats(wxWindow* parent)
: wxPanel(parent,CPPgStats::IDD)
{
	wxNotebook* book=(wxNotebook*)parent;

	wxSizer* page1=PreferencesStatisticsTab(this,TRUE);
	book->AddPage(this,_("Statistics"));
}

CPPgStats::~CPPgStats()
{
}

BEGIN_EVENT_TABLE(CPPgStats,wxPanel)
	EVT_SCROLL(CPPgStats::OnHScroll)
	EVT_BUTTON(IDC_COLOR_BUTTON,CPPgStats::OnChangeColor)
	EVT_CHOICE(IDC_COLORSELECTOR,CPPgStats::OnCbnSelchangeColorselector)
END_EVENT_TABLE()

void CPPgStats::OnChangeColor(wxEvent& evt)
{
	wxColour newcol=wxGetColourFromUser(this,((wxButton*)FindWindowById(IDC_COLOR_BUTTON))->GetBackgroundColour());
	if(newcol.Ok()) {
		((wxButton*)FindWindowById(IDC_COLOR_BUTTON))->SetBackgroundColour(newcol);
		theApp.glob_prefs->SetStatsColor(((wxChoice*)FindWindowById(IDC_COLORSELECTOR))->GetSelection(),RGB(newcol.Red(),newcol.Green(),newcol.Blue()));
	}
}

BOOL CPPgStats::OnApply()
{
	theApp.glob_prefs->SetTrafficOMeterInterval(mystats1);
	theApp.glob_prefs->SetStatsInterval(mystats2);
	theApp.glob_prefs->SetStatsAverageMinutes(mystats3);
	theApp.amuledlg->statisticswnd->ShowInterval();
	return TRUE;
}


void CPPgStats::Localize(void)
{
}

void CPPgStats::OnHScroll(wxScrollEvent& evt)
{
	wxSlider* slider = (wxSlider*)evt.GetEventObject();

	int position = evt.GetPosition();

	if (slider==((wxSlider*)FindWindowById(IDC_SLIDER))) {
		mystats1=position;
	} else if (slider==((wxSlider*)FindWindowById(IDC_SLIDER2))) {
		mystats2=position;
	} else {
		mystats3=position;
	}
	ShowInterval();
}

void CPPgStats::ShowInterval() {
	CString m_SliderValue;
	
	if (mystats1==0) {
		m_SliderValue.Format("Update delay: Disabled");
	} else {
		m_SliderValue.Format("Update delay: %i secs", mystats1);
	}
	((wxStaticText*)FindWindowById(IDC_SLIDERINFO))->SetLabel(m_SliderValue);

	if (mystats2==0) {
		m_SliderValue.Format("Update delay: Disabled");
	} else {
		m_SliderValue.Format("Update delay: %i secs", mystats2);
	}
	((wxStaticText*)FindWindowById(IDC_SLIDERINFO2))->SetLabel(m_SliderValue);

	m_SliderValue.Format("Time for average graph: %i mins", mystats3);
	((wxStaticText*)FindWindowById(IDC_SLIDERINFO3))->SetLabel(m_SliderValue);
}

void CPPgStats::LoadSettings()
{
	((wxSlider*)FindWindowById(IDC_SLIDER))->SetValue(app_prefs->GetTrafficOMeterInterval());

	((wxSlider*)FindWindowById(IDC_SLIDER2))->SetValue(app_prefs->GetStatsInterval());

	((wxSlider*)FindWindowById(IDC_SLIDER3))->SetValue(app_prefs->GetStatsAverageMinutes());

	mystats1=app_prefs->GetTrafficOMeterInterval();
	mystats2=app_prefs->GetStatsInterval();
	mystats3=app_prefs->GetStatsAverageMinutes();

	wxCommandEvent nullEvt;
	OnCbnSelchangeColorselector(nullEvt);

	ShowInterval();
}

void CPPgStats::OnCbnSelchangeColorselector(wxCommandEvent& evt)
{
	m_colors=((wxChoice*)FindWindowById(IDC_COLORSELECTOR));
	int sel=m_colors->GetSelection();
	COLORREF selcolor=theApp.glob_prefs->GetStatsColor(sel);
	//m_ctlColor.SetColor(selcolor);
	((wxButton*)FindWindowById(IDC_COLOR_BUTTON))->SetBackgroundColour(wxColour(GetRValue(selcolor),GetGValue(selcolor),GetBValue(selcolor)));
	#warning COLOR IS NOT SET
}
