// PreferencesDlg.cpp : implementation file
//

//#include "stdafx.h"
#include "wintypes.h"
#include "amule.h"
#include "PreferencesDlg.h"
#include "muuli_wdr.h"
#include "Wizard.h"

// CPreferencesDlg

//IMPLEMENT_DYNAMIC(CPreferencesDlg, CPropertySheet)
IMPLEMENT_DYNAMIC_CLASS(CPreferencesDlg,wxDialog)

BEGIN_EVENT_TABLE(CPreferencesDlg,wxDialog)
	EVT_BUTTON(ID_OK,CPreferencesDlg::OnBtnOk)
	EVT_BUTTON(ID_CANCEL,CPreferencesDlg::OnBtnCancel)
END_EVENT_TABLE()

CPreferencesDlg::CPreferencesDlg(wxWindow* parent,CPreferences* prefs)
: wxDialog(parent,9999,_("Preferences"),wxDefaultPosition,wxDefaultSize,
wxDEFAULT_DIALOG_STYLE|wxSYSTEM_MENU)
{
	wxNotebook* book=new wxNotebook(this,7773,wxPoint(0,0),wxSize(200,200));
	wxPanel* page1;

	// load pages
	m_wndGeneral=new CPPgGeneral(book);
	m_wndConnection=new CPPgConnection(book);
	m_wndServer=new CPPgServer(book);
	m_wndFiles=new CPPgFiles(book);
	m_wndDirectories=new CPPgDirectories(book);
	m_wndStats=new CPPgStats(book);
	m_wndNotify=new CPPgNotify(book);
	//m_wndIRC=new CPPgIRC();
	//m_wndIRC=NULL;
	m_wndTweaks=new CPPgTweaks(book);
	m_wndSourcesDropping = new CPPgSourcesDropping(book);  // Creating Sources Dropping window
	m_wndGuiTweaks = new CPPgGuiTweaks(book); // Creating GUI Tweaks window

	int bigbob1=m_wndSourcesDropping->GetSize().GetWidth();
	int bigbob2=(m_wndGeneral->GetSize().GetHeight()+41);
	wxSize pageSize(bigbob1,bigbob2);
	SetSize(pageSize.GetWidth(),pageSize.GetHeight()+40);
	book->SetSize(pageSize);

	// then the ok/cancel buttons please
	wxButton* mybut=new wxButton(this,ID_OK,_("OK"),
	wxPoint(pageSize.GetWidth()-2*80-16,pageSize.GetHeight()+10),wxSize(80,24));
	wxButton* otbut=new wxButton(this,ID_CANCEL,_("Cancel"),
	wxPoint(pageSize.GetWidth()-80-8,pageSize.GetHeight()+10),wxSize(80,24));

	SetPrefs(prefs);

	CentreOnParent();
}

CPreferencesDlg::~CPreferencesDlg()
{
}

int CPreferencesDlg::ShowModal()
{
	// setup pages
	m_wndGeneral->LoadSettings();
	m_wndFiles->LoadSettings();
	m_wndServer->LoadSettings();
	m_wndConnection->LoadSettings();
	m_wndDirectories->LoadSettings();
	m_wndStats->LoadSettings();
	m_wndNotify->LoadSettings();
	m_wndTweaks->LoadSettings(); 
	m_wndSourcesDropping->LoadSettings();  // Load settings in Dropping Sources window
	m_wndGuiTweaks->LoadSettings(); // Load Settings in GUI Tweaks
	// and then do the show
	return wxDialog::ShowModal();
}

void CPreferencesDlg::OnBtnWizard(wxEvent& evt)
{
	Wizard* test=new Wizard(this);
	test->SetPrefs(theApp.glob_prefs);//app_prefs);
	test->OnInitDialog();
	test->ShowModal();
	delete test;
	printf("** done\n");
}

void CPreferencesDlg::OnBtnOk(wxEvent& evt)
{
	// apply all pages
	m_wndGeneral->OnApply();
	m_wndConnection->OnApply();
	m_wndServer->OnApply();
	m_wndFiles->OnApply();
	m_wndDirectories->OnApply();
	m_wndStats->OnApply();
	m_wndNotify->OnApply();
	m_wndTweaks->OnApply();
	m_wndSourcesDropping->OnApply();  // OnApply in Sources Dropping 
	//m_wndGuiTweaks->OnApply(); // OnApply in GUI Tweaks
	app_prefs->Save();
	EndModal(0);
}

void CPreferencesDlg::OnBtnCancel(wxEvent& evt)
{
	EndModal(0);
}
