//this file is part of aMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.amule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// TransferWnd.cpp : implementation file

#include "wintypes.h"
#include "amule.h"
#include "TransferWnd.h"
#include "CatDialog.h"
#include "muuli_wdr.h"
#include <wx/settings.h>

// CTransferWnd dialog

IMPLEMENT_DYNAMIC_CLASS(CTransferWnd,wxPanel)

BEGIN_EVENT_TABLE(CTransferWnd,wxPanel)
	EVT_MULENOTEBOOK_PAGE_CHANGED(ID_CATEGORIES,CTransferWnd::OnSelchangeDltab)
	EVT_RIGHT_DOWN(CTransferWnd::OnNMRclickDLtab)
	EVT_SPLITTER_SASH_POS_CHANGED(ID_SPLATTER, CTransferWnd::OnSashPositionChanged)
END_EVENT_TABLE()

#include <wx/splitter.h>

//IMPLEMENT_DYNAMIC(CTransferWnd, CDialog)
CTransferWnd::CTransferWnd(wxWindow* pParent /*=NULL*/)
: wxPanel(pParent,CTransferWnd::IDD)
{
	SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOWFRAME));
	wxSizer* content=transferDlg(this,TRUE);
	content->Show(this,TRUE);

	wxSplitterWindow* split=(wxSplitterWindow*)FindWindow("splitterWnd");

	//wxPanel* subContent1=new wxPanel(split,-1);
	//subContent1->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOWFRAME));
	//wxSizer* subC1=transferTopPane(subContent1,TRUE);
	//wxPanel* subContent2=new wxPanel(split,-1);
	//subContent2->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOWFRAME));
	//wxSizer* subC2=transferBottomPane(subContent2,FALSE);

	//split->SplitHorizontally(subContent1,subContent2);

	uploadlistctrl=(CUploadListCtrl*)FindWindowByName("uploadList");
	downloadlistctrl=(CDownloadListCtrl*)FindWindowByName("downloadList");
	queuelistctrl=(CQueueListCtrl*)FindWindowByName("uploadQueue");
	// let's hide the queue
	queueSizer->Remove(queuelistctrl);
	//subC2->SetDimension(0,0,100,50);
	queueSizer->Layout();
	//subC2->Layout();
	queuelistctrl->Show(FALSE);
	// allow notebook to dispatch right mouse clicks to us
	CMuleNotebook* nb=(CMuleNotebook*)FindWindowById(ID_CATEGORIES);
	nb->SetMouseListener(GetEventHandler());
	windowtransferstate=false;
	CatMenu=false;
}

CTransferWnd::~CTransferWnd()
{
}

BOOL CTransferWnd::OnInitDialog() {
	m_dlTab=(CMuleNotebook*)FindWindowById(ID_CATEGORIES);

	// show & cat-tabs
	sprintf(theApp.glob_prefs->GetCategory(0)->title, "%s",GetCatTitle(theApp.glob_prefs->GetAllcatType()).GetBuffer());

	sprintf(theApp.glob_prefs->GetCategory(0)->incomingpath,"%s",theApp.glob_prefs->GetIncomingDir());
	for (int ix=0;ix<theApp.glob_prefs->GetCatCount();ix++) {
		wxPanel* nullPanel=new wxPanel(m_dlTab);
		wxString tmpstrstr(theApp.glob_prefs->GetCategory(ix)->title);
		m_dlTab->AddPage(nullPanel,"-"); // just temporary string. 
		// for some odd reason, wxwin2.5 and gtk2 will not allow non utf strings for AddPage()
		// but they will be accepted in SetPageText().. so let's use this as a countermeasure
		m_dlTab->SetPageText(ix,tmpstrstr);
	}

	return true;
}


void CTransferWnd::ShowQueueCount(uint32 number){
	char buffer[100];
	wxString fmtstr="%u (%u "+ GetResString(IDS_BANNED).MakeLower() +")";
	sprintf(buffer,fmtstr.GetData(),number,theApp.uploadqueue->GetBanCount());
	wxStaticCast(FindWindowByName("clientCount"),wxStaticText)->SetLabel(buffer);
	//this->GetDlgItem(IDC_QUEUECOUNT)->SetWindowText(buffer);
}

#if 0
void CTransferWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_UPLOADLIST, uploadlistctrl);
	DDX_Control(pDX, IDC_DOWNLOADLIST, downloadlistctrl);
	DDX_Control(pDX, IDC_QUEUELIST, queuelistctrl);
}
#endif

void CTransferWnd::SetInitLayout() {
#if 0
		CRect rcDown,rcSpl,rcW;
		CWnd* pWnd;

		GetWindowRect(rcW);
		ScreenToClient(rcW);

		LONG splitpos=(theApp.glob_prefs->GetSplitterbarPosition()*rcW.Height())/100;

		pWnd = GetDlgItem(IDC_DOWNLOADLIST);
		pWnd->GetWindowRect(rcDown);
		ScreenToClient(rcDown);
		rcDown.right=rcW.right-7;
		rcDown.bottom=splitpos-5;
		downloadlistctrl.MoveWindow(rcDown);
		
		pWnd = GetDlgItem(IDC_UPLOADLIST);
		pWnd->GetWindowRect(rcDown);
		ScreenToClient(rcDown);
		rcDown.right=rcW.right-7;
		rcDown.bottom=rcW.bottom-20;
		rcDown.top=splitpos+20;
		uploadlistctrl.MoveWindow(rcDown);

		pWnd = GetDlgItem(IDC_QUEUELIST);
		pWnd->GetWindowRect(rcDown);
		ScreenToClient(rcDown);
		rcDown.right=rcW.right-7;
		rcDown.bottom=rcW.bottom-20;
		rcDown.top=splitpos+20;
		queuelistctrl.MoveWindow(rcDown);

		rcSpl=rcDown;
		rcSpl.top=rcDown.bottom+4;rcSpl.bottom=rcSpl.top+5;rcSpl.left=95;
		m_wndSplitter.MoveWindow(rcSpl,true);

		DoResize(0);
#endif
}

void CTransferWnd::DoResize(int delta)
{
#if 0
	CSplitterControl::ChangeHeight(&downloadlistctrl, delta);
	CSplitterControl::ChangeHeight(&uploadlistctrl, -delta, CW_BOTTOMALIGN);
	CSplitterControl::ChangeHeight(&queuelistctrl, -delta, CW_BOTTOMALIGN);

	UpdateSplitterRange();

	Invalidate();
	UpdateWindow();
#endif
}

// setting splitter range limits
void CTransferWnd::UpdateSplitterRange()
{
#if 0
		CRect rcDown,rcUp,rcW,rcSpl;
		CWnd* pWnd;

		GetWindowRect(rcW);
		ScreenToClient(rcW);

		pWnd = GetDlgItem(IDC_DOWNLOADLIST);
		pWnd->GetWindowRect(rcDown);
		ScreenToClient(rcDown);

		pWnd = GetDlgItem(IDC_UPLOADLIST);
		pWnd->GetWindowRect(rcUp);
		ScreenToClient(rcUp);

		pWnd = GetDlgItem(IDC_QUEUELIST);
		pWnd->GetWindowRect(rcUp);
		ScreenToClient(rcUp);

		theApp.glob_prefs->SetSplitterbarPosition((rcDown.bottom*100)/rcW.Height());

		RemoveAnchor(IDC_DOWNLOADLIST);RemoveAnchor(IDC_UPLOADLIST);RemoveAnchor(IDC_QUEUELIST);
		AddAnchor(IDC_DOWNLOADLIST,TOP_LEFT,CSize(100,theApp.glob_prefs->GetSplitterbarPosition() ));
		AddAnchor(IDC_UPLOADLIST,CSize(0,theApp.glob_prefs->GetSplitterbarPosition()),BOTTOM_RIGHT);
		AddAnchor(IDC_QUEUELIST,CSize(0,theApp.glob_prefs->GetSplitterbarPosition()),BOTTOM_RIGHT);

		m_wndSplitter.SetRange(rcDown.top+50 , rcUp.bottom-40);
#endif
}


#if 0
LRESULT CTransferWnd::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	switch (message) {
		// arrange transferwindow layout
		case WM_PAINT:
			if (m_wndSplitter) {
				CRect rcDown,rcSpl,rcW;
				CWnd* pWnd;


				GetWindowRect(rcW);
				ScreenToClient(rcW);

				pWnd = GetDlgItem(IDC_DOWNLOADLIST);
				pWnd->GetWindowRect(rcDown);
				ScreenToClient(rcDown);

				if (rcW.Height()>0) {
					// splitter paint update
					rcSpl=rcDown;
					rcSpl.top=rcDown.bottom+8;rcSpl.bottom=rcSpl.top+5;rcSpl.left=95;
					GetDlgItem(IDC_UPLOAD_TEXT)->MoveWindow(30,rcSpl.top-5,90,16);
					GetDlgItem(IDC_UPLOAD_ICO)->MoveWindow(10,rcSpl.top-5,16,16);
					m_wndSplitter.MoveWindow(rcSpl,true);
					UpdateSplitterRange();
				}
			}
			break;
		case WM_NOTIFY:
			if (wParam == IDC_SPLITTER)
			{	
				SPC_NMHDR* pHdr = (SPC_NMHDR*) lParam;
				DoResize(pHdr->delta);
			}
			break;
		case WM_WINDOWPOSCHANGED : 
			{
				CRect rcW;
				GetWindowRect(rcW);
				ScreenToClient(rcW);

				if (m_wndSplitter && rcW.Height()>0) Invalidate();
				break;
			}
		case WM_SIZE:
			if (m_wndSplitter) {
				CRect rcDown,rcSpl,rcW;
				CWnd* pWnd;

				GetWindowRect(rcW);
				ScreenToClient(rcW);

				if (rcW.Height()>0){
					pWnd = GetDlgItem(IDC_DOWNLOADLIST);
					pWnd->GetWindowRect(rcDown);
					ScreenToClient(rcDown);

					long splitpos=(theApp.glob_prefs->GetSplitterbarPosition()*rcW.Height())/100;

					rcSpl.right=rcDown.right;rcSpl.top=splitpos+10;rcSpl.bottom=rcSpl.top+5;rcSpl.left=95;
					m_wndSplitter.MoveWindow(rcSpl,true);
				}

			}
			break;
	}
	return CDialog::DefWindowProc(message, wParam, lParam);
}
#endif

#if 0
// CTransferWnd message handlers
BOOL CTransferWnd::PreTranslateMessage(MSG* pMsg)
{
	// handle tooltip updating, when mouse is moved from one item to another
	if (pMsg->message== WM_MOUSEMOVE)
		UpdateToolTips();

	// relay mouse events to tooltip control
	if (pMsg->message== WM_LBUTTONDOWN || pMsg->message== WM_LBUTTONUP || pMsg->message== WM_MOUSEMOVE)
		m_ttip.RelayEvent(pMsg);

	return CResizableDialog::PreTranslateMessage(pMsg);
}
#endif

void CTransferWnd::UpdateToolTips(void)
{
#if 0
	int sel = GetItemUnderMouse(&downloadlistctrl);
	if (sel != -1)
	{
		if (sel != m_iOldToolTipItemDown)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.Update();
			m_iOldToolTipItemDown = sel;
			return;
		}
	}
	int sel2 = GetItemUnderMouse(&uploadlistctrl);
	if (sel2 != -1)
	{
		if (sel2 != m_iOldToolTipItemUp)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.Update();
			m_iOldToolTipItemUp = sel2;
			return;
		}
	}
/* no tooltips needed ATM
	int sel3 = GetItemUnderMouse(&queuelistctrl);
	if (sel3 != -1)
	{
		if (sel3 != m_iOldToolTipItemQueue)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.Update();
			m_iOldToolTipItemQueue = sel3;
		}
	}
*/
	if (sel == -1 && sel2 == -1 /*&& sel3 != -1*/)
		m_ttip.Pop();

#endif
}

int CTransferWnd::GetItemUnderMouse(wxListCtrl* ctrl)
{
#if 0
	CPoint pt;
	::GetCursorPos(&pt);
	ctrl->ScreenToClient(&pt);
	LVHITTESTINFO hit, subhit;
	hit.pt = pt;
	subhit.pt = pt;
	ctrl->SubItemHitTest(&subhit);
	int sel = ctrl->HitTest(&hit);
	if (sel != LB_ERR && (hit.flags & LVHT_ONITEM))
	{
		if (subhit.iSubItem == 0)
			return sel;
	}
	return LB_ERR;
#endif
}

void CTransferWnd::SwitchUploadList(wxCommandEvent& evt)
{
	if( windowtransferstate == false) {
		windowtransferstate=true;
		// hide the upload list
		queueSizer->Remove(uploadlistctrl);
		uploadlistctrl->Show(FALSE);
		queueSizer->Add(queuelistctrl,1,wxGROW|wxALIGN_CENTER_VERTICAL ,5);
		queuelistctrl->Show();
		queueSizer->Layout();
		wxStaticCast(FindWindowByName("uploadTitle"),wxStaticText)->SetLabel(GetResString(IDS_ONQUEUE));
	} else {
		windowtransferstate=false;
		// hide the queuelist
		queueSizer->Remove(queuelistctrl);
		queuelistctrl->Show(FALSE);
		queueSizer->Add(uploadlistctrl,1,wxGROW|wxALIGN_CENTER_VERTICAL, 5);
		uploadlistctrl->Show();
		queueSizer->Layout();
		wxStaticCast(FindWindowByName("uploadTitle"),wxStaticText)->SetLabel(GetResString(IDS_TW_UPLOADS));
	}
}

void CTransferWnd::Localize()
{
}


void CTransferWnd::OnSelchangeDltab(wxNotebookEvent& evt)
{
  downloadlistctrl->ChangeCategory(evt.GetSelection());
  downloadlistctrl->InitSort();
}

void CTransferWnd::OnNMRclickDLtab(wxMouseEvent& evt) {
	CMuleNotebook* nb=(CMuleNotebook*)FindWindowById(ID_CATEGORIES);
	if(nb->GetSelection()==-1) {
		return;
	}
	
	// Avoid opening another menu when it's already open
	if (CatMenu==false) {  
		
		CatMenu=true;
		wxMenu* menu=new wxMenu(GetResString(IDS_CAT));

		if(nb->GetSelection()==0) {
			wxMenu* m_CatMenu=new wxMenu();

			m_CatMenu->Append(MP_CAT_SET0,GetResString(IDS_ALL) );
			m_CatMenu->Append(MP_CAT_SET0+1,GetResString(IDS_ALLOTHERS) );
			m_CatMenu->AppendSeparator();
			m_CatMenu->Append(MP_CAT_SET0+2,GetResString(IDS_STATUS_NOTCOMPLETED) );
			m_CatMenu->Append(MP_CAT_SET0+3,GetResString(IDS_DL_TRANSFCOMPL) );
			m_CatMenu->Append(MP_CAT_SET0+4,GetResString(IDS_WAITING) );
			m_CatMenu->Append(MP_CAT_SET0+5,GetResString(IDS_DOWNLOADING) );
			m_CatMenu->Append(MP_CAT_SET0+6,GetResString(IDS_ERRORLIKE) );
			m_CatMenu->Append(MP_CAT_SET0+7,GetResString(IDS_PAUSED) );
			m_CatMenu->Append(MP_CAT_SET0+8,GetResString(IDS_STOPPED) );
			m_CatMenu->AppendSeparator();
			m_CatMenu->Append(MP_CAT_SET0+9,GetResString(IDS_VIDEO) );
			m_CatMenu->Append(MP_CAT_SET0+10,GetResString(IDS_AUDIO) );
			m_CatMenu->Append(MP_CAT_SET0+11,GetResString(IDS_SEARCH_ARC) );
			m_CatMenu->Append(MP_CAT_SET0+12,GetResString(IDS_SEARCH_CDIMG) );
			m_CatMenu->Append(MP_CAT_SET0+13,GetResString(IDS_SEARCH_PICS) );
			m_CatMenu->Append(MP_CAT_SET0+14,GetResString(IDS_TEXT) );
			//m_CatMenu.CheckMenuItem( MP_CAT_SET0+theApp.glob_prefs->GetAllcatType() ,MF_CHECKED | MF_BYCOMMAND);
			menu->Append(47321,GetResString(IDS_CHANGECATVIEW),m_CatMenu);
		}

		menu->Append(MP_CAT_ADD,GetResString(IDS_CAT_ADD));
		menu->Append(MP_CAT_EDIT,GetResString(IDS_CAT_EDIT));
		menu->Append(MP_CAT_REMOVE, GetResString(IDS_CAT_REMOVE));
		menu->AppendSeparator();
		//menu->Append(472834,GetResString(IDS_PRIORITY),m_PrioMenu);

		menu->Append(MP_CANCEL,GetResString(IDS_MAIN_BTN_CANCEL) );
		menu->Append(MP_STOP, GetResString(IDS_DL_STOP));
		menu->Append(MP_PAUSE, GetResString(IDS_DL_PAUSE));
		menu->Append(MP_RESUME, GetResString(IDS_DL_RESUME));
		//menu->Append(MP_RESUMENEXT, GetResString(IDS_DL_RESUMENEXT));                                                                                
		// the point coming from mulenotebook control isn't in screen coordinates
		// (unlike std mouse event, which always returns screen coordinates)
		// so we must do the conversion here
		wxPoint pt=evt.GetPosition();
		wxPoint newpt=nb->ClientToScreen(pt);
		newpt=ScreenToClient(newpt);
		//evt.Skip();
		PopupMenu(menu,newpt);
		delete menu;

		CatMenu=false;
	}
}

bool CTransferWnd::ProcessEvent(wxEvent& evt)
{
	if(evt.GetEventType()!=wxEVT_COMMAND_MENU_SELECTED) {
		return wxPanel::ProcessEvent(evt);
	}
	/*
	if(evt.GetEventObject()!=this)
	return wxPanel::ProcessEvent(evt);
	*/
	wxCommandEvent& event=(wxCommandEvent&)evt;
	switch(event.GetId()) {
		case MP_CAT_SET0: 
		case MP_CAT_SET0+1: 
		case MP_CAT_SET0+2: 
		case MP_CAT_SET0+3: 
		case MP_CAT_SET0+4: 
		case MP_CAT_SET0+5: 
		case MP_CAT_SET0+6: 
		case MP_CAT_SET0+7:
		case MP_CAT_SET0+8: 
		case MP_CAT_SET0+9:
		case MP_CAT_SET0+10: 
		case MP_CAT_SET0+11:
		case MP_CAT_SET0+12: 
		case MP_CAT_SET0+13: 
		case MP_CAT_SET0+14: {
			theApp.glob_prefs->SetAllcatType(event.GetId()-MP_CAT_SET0);
			sprintf(theApp.glob_prefs->GetCategory(0)->title, "%s", GetCatTitle(theApp.glob_prefs->GetAllcatType()).GetBuffer());
			CString csName;
			csName.Format("%s", theApp.glob_prefs->GetCategory(0)->title );
			EditCatTabLabel(0,csName);
			downloadlistctrl->ChangeCategory(0);
			downloadlistctrl->InitSort();
			break;
		}

		case MP_CAT_ADD: {
			int m_nLastCatTT=-1;
			int newindex=AddCategorie("?",theApp.glob_prefs->GetIncomingDir(),"",false);
			//m_dlTab.InsertItem(newindex,theApp.glob_prefs->GetCatego
			//	       ry(newindex)->title);
			wxPanel* nullPanel=new wxPanel(m_dlTab,-1);
			m_dlTab->AddPage(nullPanel,theApp.glob_prefs->GetCategory(newindex)->title);
			CCatDialog dialog(this,newindex);
			dialog.OnInitDialog();
			//dialog.DoModal();
			dialog.ShowModal();
			#warning TODO: fix this
			//theApp.emuledlg->searchwnd->UpdateCatTabs();
			EditCatTabLabel(newindex,theApp.glob_prefs->GetCategory(newindex)->title);
			theApp.glob_prefs->SaveCats();
			break;
		}
		case MP_CAT_EDIT: {
			int m_nLastCatTT=-1;
			CCatDialog dialog(this,m_dlTab->GetSelection());
			dialog.OnInitDialog();
			dialog.ShowModal();

			CString csName;
			csName.Format("%s", theApp.glob_prefs->GetCategory(m_dlTab->GetSelection())->title );
			EditCatTabLabel(m_dlTab->GetSelection(),csName);

			#warning TODO: fix this
			//theApp.emuledlg->searchwnd.UpdateCatTabs();
			theApp.glob_prefs->SaveCats();
			break;
		}
		case MP_CAT_REMOVE: {
			int m_nLastCatTT=-1;
			theApp.downloadqueue->ResetCatParts(m_dlTab->GetSelection());
			theApp.glob_prefs->RemoveCat(m_dlTab->GetSelection());
			m_dlTab->RemovePage(m_dlTab->GetSelection());
			m_dlTab->SetSelection(0);
			downloadlistctrl->ChangeCategory(0);
			theApp.glob_prefs->SaveCats();
			if (theApp.glob_prefs->GetCatCount()==1) theApp.glob_prefs->SetAllcatType(0);
			#warning TODO: fix this
			//theApp.emuledlg->searchwnd.UpdateCatTabs();
			break;
		}
		case MP_PRIOLOW: {
			theApp.downloadqueue->SetCatPrio(m_dlTab->GetSelection(),PR_LOW);
			break;
		}
		case MP_PRIONORMAL: {
			theApp.downloadqueue->SetCatPrio(m_dlTab->GetSelection(),PR_NORMAL);
			break;
		}
		case MP_PRIOHIGH: {
			theApp.downloadqueue->SetCatPrio(m_dlTab->GetSelection(),PR_HIGH );
			break;
		}
		case MP_PRIOAUTO: {
			theApp.downloadqueue->SetCatPrio(m_dlTab->GetSelection(),PR_AUTO );
			break;
		}
		case MP_PAUSE: {
			theApp.downloadqueue->SetCatStatus(m_dlTab->GetSelection(),MP_PAUSE);
			break;
		}
		case MP_STOP : {
			theApp.downloadqueue->SetCatStatus(m_dlTab->GetSelection(),MP_STOP);
			break;
		}

		case MP_CANCEL: 
			if (wxMessageBox(GetResString(IDS_CATEGORY_DELETE),GetResString(IDS_CONFIRMATION),
			   wxYES_NO|wxCENTRE|wxICON_EXCLAMATION) == wxYES) {
				theApp.downloadqueue->SetCatStatus(m_dlTab->GetSelection(),MP_CANCEL);
			}
			break;
		
		case MP_RESUME: {
			theApp.downloadqueue->SetCatStatus(m_dlTab->GetSelection(),MP_RESUME);
			break;
		}
		#if 0
		case MP_RESUMENEXT:
			theApp.downloadqueue->StartNextFile(m_dlTab->GetSelection());
			break;
		#endif
		case IDC_UPLOAD_ICO: {
			wxCommandEvent nullEvt;
			SwitchUploadList(nullEvt);
			break;
		}
		case IDC_QUEUE_REFRESH_BUTTON: {
			#warning TODO: fix this
			//OnBnClickedQueueRefreshButton();
			break;
		}
		default: {
			return wxPanel::ProcessEvent(evt);
		}
	}
	return false;
}

int CTransferWnd::AddCategorie(CString newtitle,CString newincoming,CString newcomment,bool addTab){
        Category_Struct* newcat=new Category_Struct;

        sprintf(newcat->title,"%s",newtitle.GetBuffer());
        newcat->prio=0;
        sprintf(newcat->incomingpath,"%s",newincoming.GetBuffer());
        sprintf(newcat->comment,"%s",newcomment.GetBuffer());
        int index=theApp.glob_prefs->AddCat(newcat);
        
        if (addTab) {
	  //m_dlTab.InsertItem(index,newtitle);
	  wxPanel* nullPanel=new wxPanel(m_dlTab,-1);
	  m_dlTab->AddPage(nullPanel,newtitle);
	}
        return index;
}

void CTransferWnd::EditCatTabLabel(int index,CString newlabel) {
  //TCITEM tabitem;
  //tabitem.mask = TCIF_PARAM;
  //m_dlTab.GetItem(index,&tabitem);
  //tabitem.mask = TCIF_TEXT;
  
  if (theApp.glob_prefs->ShowCatTabInfos()) {
    CPartFile* cur_file;
    uint16 count,dwl;
    count=dwl=0;
    for (int i=0;i<theApp.downloadqueue->GetFileCount();i++) {
      cur_file=theApp.downloadqueue->GetFileByIndex(i);
      if (cur_file==0) continue;
      if (CheckShowItemInGivenCat(cur_file,index)) {
	count++;
	if (cur_file->GetTransferingSrcCount()>0) dwl++;
	//                              speed+=cur_file->GetDatarate()/1024.0f;
	//                              size+=cur_file->GetFileSize();
	//                              trsize+=cur_file->GetCompletedSize();
      }
    }
    CString title=newlabel;
    newlabel.Format("%s (%i/%i)",title.GetData(),dwl,count);
  }
  
  //tabitem.pszText = newlabel.LockBuffer();
  //m_dlTab.SetItem(index,&tabitem);
  //newlabel.UnlockBuffer();
  m_dlTab->SetPageText(index,newlabel);
}

void CTransferWnd::OnSashPositionChanged()
{
	theApp.amuledlg->split_pos = ((wxSplitterWindow*)FindWindow("splitterWnd"))->GetSashPosition();
}
